/**
*author: Daniel Quilon Gonzalez
*version: 1-sept-11
**/

var document_url = location.href;
var xmlIdeasURL = "";
var xmlSkillsURL = "";
var ideas_source,talents_source,module_path = "";


window.setTimeout("get_sources()",200);

$(document).ready(function() {
  	recomender_idea_title = $('.with-tabs').text();				
	$('.with-tabs').remove();
});

function get_sources(){
	module_path = Drupal.settings.location.module_path;
	ideas_source = Drupal.settings.current_sources.ideas_source;
	talents_source = Drupal.settings.current_sources.talents_source;
	get_file_path();
	try_load_xml_ideas_file(ideas_source);
}

function try_load_xml_ideas_file(ideas_source){
	xmlIdeasURL = ideas_source;
	$.ajax({
		type: "GET",
		url: ideas_source,
		cache: false,
		dataType: "xml",		
		success: start_parsing,
		error: function(){
			alert("Loaded ideas file not found\nA default file will be loaded.");
			xmlIdeasURL = xmlIdeasURL;
			start_parsing();				
        }
    });
}

function try_load_xml_talents_file(talents_source){
	$.ajax({
		type: "GET",
		url: talents_source,
		cache: false,
		dataType: "xml",		
		success: parseSkills,
		error: function(){
			alert("Loaded talents file not found\nA default file will be loaded.");
			get_ideas_rdf();				
        }
    });
}

function get_file_path(){
var start = document_url.search("index.html?");
var url_files = document_url.substring(start + 11);
if(url_files.search("&") != -1){	
	var location_files = url_files.split("&");
	/****get url xml ideas****/	
	if((location_files[0].search("ideas=") != -1) || (location_files[1].search("ideas=") != -1)){
		if(location_files[0].search("ideas=") != -1){
			xmlIdeasURL = location_files[0].substring("ideas=".length);
		}else{
			xmlIdeasURL = location_files[1].substring("ideas=".length);
		}	
	}else{
		xmlIdeasURL = "./"+ module_path +"/xmlLoader/etsit_ideas_example.rdf";
	}
	/****get url xml skills****/
	if((location_files[0].search("skills=") != -1) || (location_files[1].search("skills=") != -1)){
		if(location_files[0].search("skills=") != -1){
			xmlSkillsURL = location_files[0].substring("skills=".length);
		}else{
			xmlSkillsURL = location_files[1].substring("skills=".length);
		}	
	}else{
		xmlSkillsURL = "./"+ module_path +"/xmlLoader/talent_management_v1_extended.rdf";
	}
}else{
	if(url_files.search("ideas=") != -1){
		xmlIdeasURL = url_files.substring("ideas=".length);;
	}else{
		xmlIdeasURL = "./"+ module_path +"/xmlLoader/etsit_ideas_example.rdf";
	}
	if(url_files.search("skills=") != -1){
		xmlSkillsURL = url_files.substring("skills=".length);;
	}else{
		xmlSkillsURL = "./"+ module_path +"/xmlLoader/talent_management_v1_extended.rdf";
	}
}	
}


function start_parsing(){	
	$.ajax({
		type: "GET",
		url: xmlIdeasURL,
		cache: false,
		dataType: "xml",		
		success: parsexml,
		error: function(){
			alert("URL ideas file not found\nA default file will be loaded.");
				xmlIdeasURL = "./"+ module_path +"/xmlLoader/etsit_ideas_example.rdf";
				start_parsing();
        }
    });
}

function get_ideas_rdf(){		
	$.ajax({
		type: "GET",
		url: xmlSkillsURL,
		cache: false,
		dataType: "xml",		
		success: parseSkills,
		error: function(){
            alert("URL talents file not found\nA default file will be loaded.");
				xmlSkillsURL = "./"+ module_path +"/xmlLoader/talent_management_v1_extended.rdf";	
				get_ideas_rdf();
        }
	});
}


var title, category, status, content, tags = "";
var idea_triple, user_triple, category_triple, tag_triple;
var opinions = new Array();//[0] = positive opinions, [1] = neutral opinions, [2] = positive opinions
var idea_number = 0;
var user_number_recomender = 0;
var user_name = "";
var skills_array = new Array(); var data = new Array();
var user_triple = "";
var usersskillsvalue = new Array();
var about_user = new Array();
var creator;
var sidea;
var suser;
var sskillvalue;
var dataUser = new Array();
var recomender_tags="";
var recomender_users = new Array();


function parsexml(xml1){	
	$(xml1).find("Idea").each(function(){//for each idea		
		idea_triple	= 	$(this).attr("rdf:about");		
		title = $(this).find("title").text();//Idea's title
		if(title == recomender_idea_title){	
			$(this).find("hasCreator").each(function(){//Idea's creator
				creator = $(this).attr("rdf:resource");	
				user_triple = $(this).attr("rdf:resource");		
				$(xml1).find("User").each(function(){
					if($(this).attr("rdf:about") == user_triple){					
						user_name = $(this).find("accountName").text();
						if(title == recomender_idea_title){
							recomender_creator = $(this).find("accountName").text();					
						}														
					}
				});
			});
			$(this).find("hasCategory").each(function(){//Idea's category	
				category_triple = $(this).attr("rdf:resource");		
				$(xml1).find("Category").each(function(){
					if(($(this).attr("rdf:about") == category_triple)){				
						category = $(this).find("title").text();							
					}
				});
			});		
			status = $(this).find("hasStatus").text();//Idea's status		
			content = $(this).find("content").text();//Idea's content
			s_content = content.split(".");		
			$(this).find("hasTag").each(function(){//Idea's tags	
				tag_triple = $(this).attr("rdf:resource");		
				$(xml1).find("Tag").each(function(){
					if(($(this).attr("rdf:about") == tag_triple)){			
						tags = tags + ", " + $(this).find("name").text();														
					}
				});
			});
			opinions[0] = $(this).find("positiveOpinionsCount").text();
			opinions[1] = $(this).find("neutralOpinionsCount").text();
			opinions[2] = $(this).find("negativeOpinionsCount").text();		
			tags = tags.substring(1);
			
			var idea_1 = ("<ul class = 'myparameters'>"+ 
					 "<li class = 'uri'><b>Title:</b> "+ recomender_idea_title + "</li>"+ 
					 "<li class = 'uri'><b>URI:</b> "+ idea_triple + "</li>"+
					 "<li class = 'mystatus'><b>Status:</b> " + status + "</li>"+
					 "<li class = 'myContent'><b>Content:</b> " + s_content[0]+ "</li>"+"</ul>");
			$('#idea_1').append(idea_1);

			var idea_2 = ("<ul class = 'myparameters'>"+ 
					 "<li class = 'mycategory'><b>Category:</b> " + category + "</li>"+
					 "<li class = 'mytags'><b>Tags:</b> " + tags + "</li>"+
					 "<li class = 'posop'><b>Positive opinion:</b> " + opinions[0] + "</li>"+
					 "<li class = 'neusop'><b>Neutral opinion:</b> " + opinions[0] + "</li>"+ 
					 "<li class = 'negatsop'><b>Negative opinion:</b> " + opinions[0] + "</li>"+"</ul>");					 
			$('#idea_2').append(idea_2);
			
			if(title == recomender_idea_title){
				recomender_tags = tags;
			}
		}
			//reset_triples();			
		});
		try_load_xml_talents_file(talents_source);
}


function parseSkills(xml2){ 
	var skills_value = 0;
   var skill_triple = "";
	var activity_triple = "";
	var skill_experience = 0;
   var skill_level = 0;	
	var activity_date = 0;		
	
	$(xml2).find("CV").each(function(){
		user_number_recomender++;
		about_user[user_number_recomender] = $(this).attr("rdf:about");
		$(this).find("hasIdeaManagementProfile").each(function(){					
					var user_name_recomender = $(this).parent().find("firstName").text();
					suser = ("<ul id = 'userparameters'>" +
					 "<li class = 'firstname'><b>Name: </b>" + user_name_recomender + "</li>"+
					 "<li class = 'lastname'><b>Last name: </b>" + $(this).parent().find("lastName").text() + "</li>"+
					 "<li class = 'accountname'><b>Account name: </b>" + $(this).parent().find("accountName").text() + "</li>"+
					 "<li class = 'jobtitle'><b>Job title: </b>" + $(this).parent().find("jobTitle").text() + "</li>"+
					 "<li class = 'startdate'><b>Start date: </b>" + $(this).parent().find("startDate").text() + "</li>"+
					 "<li class = 'created'><b>Created: </b>" + $(this).parent().find("created").text() + "</li>"+
					 "<li class = 'skills'><b>Skills:</b></br>");										
					var tag_of_an_idea = recomender_tags.split(","); //creates an array with this idea's tags
					dataUser[user_number_recomender] = suser;
					/****find Activity****/
					$(this).parent().find("hasActivity").each(function(){
						activity_triple = $(this).attr("rdf:resource");		
						$(xml2).find("Activity").each(function(){							
							if(activity_triple == $(this).attr("rdf:about")){
								activity_date = $(this).find("created").text();								
								skills_value += calculate_activity_value(activity_date);													
							}
						});
					});						
					$(this).parent().find("hasSkill").each(function(){
						skill_triple = $(this).attr("rdf:resource");
						if(skill_triple.search("#skill") == -1){											
						/****Tipe1****/
							$(xml2).find("Skill").each(function(){
								if(skill_triple == $(this).attr("rdf:about")){
									var this_skill = $(this).find("skillName").text();
									dataUser[user_number_recomender] += "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; &#8226;<b>&nbsp;" + this_skill + "</b>";
									this_skill	= 	this_skill.toLowerCase().trim();
									skill_level = $(this).find("skillLevel").text();
									skill_experience = $(this).find("skillYearsExperience").text();
									dataUser[user_number_recomender]+= ": level: " + skill_level + 	", experience: " + skill_experience + "</br>";
									if(match_skills_with_tags(this_skill, tag_of_an_idea)){																				
										skills_value += 1.5*calculate_skills_value(skill_experience, skill_level);							
									}
								}
							});
						/****Tipe1 FIN****/
						/****Tipe2****/
							var this_skill	= 	skill_triple.substring(skill_triple.search("#skill") + "#skill/".length);
							this_skill	= 	this_skill.toLowerCase().trim();								
							if(match_skills_with_tags(this_skill, tag_of_an_idea)){														
								skills_value += 1.5*calculate_skills_value(skill_experience, skill_level);											
							}						
						}
						/****Tipe2 FIN****/
					});

					
				/***user found***/				
				dataUser[user_number_recomender] += "</li>";	
				usersskillsvalue[user_number_recomender] = parseInt(skills_value/10);		
	
				$("tbody").append("<tr id =" + '\"' + user_number_recomender + '\"' + "><td id='user_recomender'>User</td><td id='ideas_users'  >" + user_name_recomender + "</td><td id ='skillsvalue'>" + parseInt(skills_value/10) + "</td></tr>");
				skills_value = 0;									
		});				
	});

put_data_on_table();	
}

function calculate_skills_value(experience,level){	
	if(experience == ""){
		experience = 0;
	}else{
		experience = parseInt(experience);
	}
	if(level == ""){
		level = 0;
	}else{
		level = parseInt(level);
	}	
	return (10 * (1 + experience + level));
}


function calculate_activity_value(date){
	var day_to_milliseconds = 24*3600*100000;
	if(date == 0){
		userDate = 0;
	}else{
		var localDate = new Date();
		localDate = Date.parse(localDate);		
		var userDate = (Math.abs(localDate - date)/day_to_milliseconds);
	}		
	return parseInt(userDate);
}


function match_skills_with_tags(this_skill, tag_of_an_idea){	
	for(l = 0; l < tag_of_an_idea.length; l++){
		var myTag = tag_of_an_idea[l].split(" ");		
		for(m = 0; m < myTag.length; m++){
			if(this_skill == myTag[m].toLowerCase().trim()){
				return true;
			}				
		}
	}	
	return false;
}

function add_skills_value_to_table(skills_value, idea_number){
	$("tbody").find("tr").each(function(){		
		if($(this).attr("id") == idea_number){
			$(this).append("<td id ='skillsvalue'>" + parseInt(skills_value/10) + "</td>");
		}
	});
}



function reset_triples(){
	idea_triple = "";	
	category_triple = "";
	tag_triple = "";
}

function generateRDF(){
	var toRDF = ("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
					+"<rdf:RDF xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n"
					+"xmlns:foaf=\"http://xmlns.com/foaf/0.1/\"\n"
					+"xmlns:dcterms=\"http://purl.org/dc/terms/\"\n"
					+"xmlns:gi2mo=\"http://purl.org/gi2mo/ns#\"\n"
					+"xmlns:marl=\"http://purl.org/marl/ns#\"\n"
					+"xmlns:cv=\"http://kaste.lv/~captsolo/semweb/resume/cv.rdfs#\">\n\n");
	
	for( user_number_index = 1; user_number_index <= user_number_recomender; user_number_index++){
		toRDF += ("<cv:CV rdf:about=\""+ about_user[user_number_index] +"\">\n"

						);
	}
	toRDF += "</rdf:RDF>";
alert(toRDF);

}



function put_data_on_table() {
	/*
	 * First step is to create title attributes for the rows in the table
	 * This isn't needed if the required 'title' attribute is already set in the HTML in the
	 * DOM 
	 */

var current_tr = "";
var myText = "";

$('#example td#ideas_users').each(function(){
	$(this).qtip({  		
		content: dataUser[$(this).parent().attr('id')],
   	show: { when: { event: 'click' } },
   	hide: 'mouseout',
		position: {
			corner: {
         	target: 'topRight',
         	tooltip: 'topRight'
      	},
   		target: 'mouse',
   		adjust: { mouse: true, x:-25, y:-100 }
		},
		show: { effect: { type: 'fade' , length: 300 } },
		style: {
			'list-style':'none',
			'font-size': '100%',			
			color:'#5787B3',	
			background: '#FFFFFF',
			width: { max: 450 },
			border: {
      	   width: 3,
      	   radius: 5,
      	   color: '#AFCCD3'
      	},   	   
   	}
	});
});


$('#example td#skillsvalue').qtip({  		
	content: "(10 x Skill + 10 x Experience + 10 x Level + Activity)/10 = Skill value",
   show: { when: { event: 'click' } },
   hide: 'mouseout',
	position: {
		corner: {
         	target: 'topRight',
         	tooltip: 'topRight'
      },
   	target: 'mouse',
   	adjust: { mouse: true, x:-15, y:10 }
	},
	show: { effect: { type: 'fade' , length: 300 } },
	style: {
			'font-size': '90%',	
			color:'#5787B3',			
			background: '#FFFFFF',
			width: { max: 450 },
			border: {
      	   width: 3,
      	   radius: 5,
      	   color: '#AFCCD3'
      	},   	   
   	}
});


/*Custom buttom*/
TableTools.BUTTONS.xml = {
	"sAction": "text",
	"sFieldBoundary": "",
	"sFieldSeperator": "\t",
	"sNewLine": "<br>",
	"sToolTip": "",
	"sButtonClass": "DTTT_button_text",
	"sButtonClassHover": "DTTT_button_text_hover",
	"sButtonText": "XNL/RDF",
	"mColumns": "all",
	"bHeader": true,
	"bFooter": true,
	"sDiv": "",
	"fnMouseover": null,
	"fnMouseout": null,
	"fnClick": function( nButton, oConfig ) {
		generateRDF();
	},
	"fnSelect": null,
	"fnComplete": null,
	"fnInit": null
};

	/* Init DataTables */
		var oTable = $('#example').dataTable({		
		"aLengthMenu": [[10, 25, 50, -1], [10, 25, 50, "All"]],
		"bJQueryUI": true,
		"sPaginationType": "full_numbers",
		"aaSorting": [[ 2, "desc" ]],
		"aoColumns": [ 
			/* Idea */   { "bSearchable": false,"bVisible":    false },
			/* User */  null,
			/* skill's value */    null ],
		"bJQueryUI": true,
		"sDom": '<"H"Tfr>t<"F"ip>',
		"oTableTools": {
			"sSwfPath": "http://dl.dropbox.com/u/6030239/swf/copy_cvs_xls_pdf.swf",
			"aButtons": [
				"copy", "csv", "xls", "pdf","print"]
				//"copy", "csv", "xls", "pdf","print",{"sExtends":"xml","sButtonText": "XML/RDF","sDiv":"copy",}]
		}
	});
	
	/* Apply the tooltips */
	$( oTable.fnGetNodes() ).tooltip( {
		"delay": 0,
		"track": true,
		"fade": 250
	} );
}




